/*
 *
 *   Copyright (c) International Business Machines  Corp., 2001
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Module: discover.h
 *
 */

/*
 * Global data exported by discover.c
 */

extern BOOLEAN discover_in_progress;

/*
 * Global functions exported by discover.c
 */

extern BOOLEAN remove_corrupt_object(ADDRESS   object,
                                     TAG       object_tag,
                                     ADDRESS   object_handle,
                                     ADDRESS   parameters,
                                     BOOLEAN * free_memory,
                                     uint    * error);

extern int hasa_dev_node(char * volume_name,
                         u_int32_t major,
                         u_int32_t minor);

extern int ensure_dev_node(char    * name,
                           u_int32_t major,
                           u_int32_t minor);

extern int make_object_dev_node(ADDRESS object,
                                TAG     object_tag,
                                ADDRESS object_handle,
                                ADDRESS parameters);

extern int check_for_stop_data(ADDRESS object,
                               TAG     object_tag,
                               ADDRESS object_handle,
                               ADDRESS parameters);

extern char * status_dots(int * status_count);

extern int discover_logical_disks(dlist_t object_list);

extern int compare_objects(ADDRESS   object1,
                           TAG       object1_tag,
                           ADDRESS   object2,
                           TAG       object2_tag,
                           uint    * error);

extern int compare_containers(ADDRESS   object1,
                              TAG       object1_tag,
                              ADDRESS   object2,
                              TAG       object2_tag,
                              uint    * error);

extern int compare_volumes(ADDRESS   object1,
			   TAG       object1_tag,
			   ADDRESS   object2,
			   TAG       object2_tag,
			   uint    * error);

extern int do_discovery(void);

extern int set_volume_in_object(ADDRESS object,
                                TAG     object_tag,
                                ADDRESS object_handle,
                                ADDRESS parameters);

extern int get_volume_sizes_and_limits(logical_volume_t * vol);

extern void find_fsim_for_volume(logical_volume_t * volume);

extern int make_volume_dev_node(logical_volume_t * volume);

extern int make_volume(storage_object_t * object,
                       char             * name,
                       u_int32_t          major,
                       u_int32_t          minor,
                       u_int32_t          flags,
                       u_int64_t          serial);

extern int sync_volume_minors_with_evms_kernel(void);

extern void feature_header_disk_to_cpu(evms_feature_header_t * fh);
