/*
 *   Copyright (c) International Business Machines  Corp., 2001
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Module: dm.h
 */

#ifndef _DM_H_INCLUDED_
#define _DM_H_INCLUDED_ 1

/* Data to be chared sith other Engine source files. */
extern unsigned long dm_ioctls[];


/* Plugin common-service APIs provided by dm.c */

extern dm_target_t * dm_allocate_target(dm_target_type type,
					u_int64_t start,
					u_int64_t length,
					u_int32_t num_stripes);

extern void dm_add_target(dm_target_t * target, dm_target_t ** target_list);

extern void dm_deallocate_targets(dm_target_t * target_list);

extern int dm_suspend(storage_object_t *object, int suspend);

extern int dm_activate(storage_object_t * object, dm_target_t * target_list);

extern int dm_activate_volume(logical_volume_t * volume, dm_target_t * target_list);

extern int dm_deactivate(storage_object_t * object);

extern int dm_deactivate_volume(logical_volume_t * volume);

extern int dm_rename(storage_object_t * object, char * old_name, char * new_name);

extern int dm_rename_volume(logical_volume_t * volume, char * old_name, char * new_name);

extern int dm_update_status(storage_object_t * object);

extern int dm_update_volume_status(logical_volume_t * volume);

extern int dm_get_targets(storage_object_t * object, dm_target_t ** target_list);

extern int dm_get_info(storage_object_t *object, char ** info);

/* Internal functions to share with other Engine source modules */

extern int dm_check_version(void);

#endif

