/*
 *   Copyright (c) International Business Machines  Corp., 2001
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Module: aixregmgr
 * File: aix_io.h
 */

#ifndef _AIX_IO_H_
#define _AIX_IO_H_

#define READ( object, lsn, count, buf )  ((object)->plugin->functions.plugin->read(  object, lsn, count, buf ))
#define WRITE(object, lsn, count, buf )  ((object)->plugin->functions.plugin->write( object, lsn, count, buf ))
#define KILL_SECTORS(object, lsn, count) ((object)->plugin->functions.plugin->add_sectors_to_kill_list( object, lsn, count ))

extern int aix_read_ipl(        storage_object_t        * object,
				aix_ipl_rec_t           ** ipl );
extern int aix_write_ipl(       storage_object_t        * object );
extern int aix_read_lvm(        storage_object_t        * object,
				aix_lvm_rec_t           ** lvm );
extern int aix_write_lvm(       storage_object_t        * object );
extern int aix_read_vg_headers( storage_object_t        * object );
extern int aix_write_vg_header( storage_object_t        * object,
				unsigned int            copy );
extern int aix_read_vg_trailers(storage_object_t        * object );
extern int aix_write_vg_trailer(storage_object_t        * object,
				unsigned int            copy );
extern int aix_read_lv_array(   storage_object_t        * object,
				unsigned int            copy );
extern int aix_write_lv_array(  storage_object_t        * object,
				unsigned int            copy );
extern int aix_read_lv_names(   storage_object_t        * object,
				unsigned int            copy );
extern int aix_write_lv_names(  storage_object_t        * object,
				unsigned int            copy );
extern int aix_read_pvs(        storage_object_t        * object,
				unsigned int            copy );
extern int aix_write_pvs(       storage_object_t        * object,
				unsigned int            copy );
extern int aix_read_vgsa(       storage_object_t        * object,
				unsigned int            copy );
extern int aix_write_vgsa(      storage_object_t        * object,
				unsigned int            copy );
extern int aix_erase_container_metadata( storage_object_t * object );
extern int aix_erase_pv_metadata( storage_object_t * object );

extern int AIX_remap_sector(storage_object_t        * region,
			    lsn_t                     org_sector,  // logical sector to remap
			    sector_count_t            size,		   // size (in sectors) of request to remap
			    lsn_t                   * new_sector,  // remapped sector
			    sector_count_t          * new_size,	   // new size (in sectors)
			    storage_object_t       ** pv_entry);   // new node for which new_sector is relative

extern inline u_int64_t bytes_to_sectors( u_int64_t bytes );
extern inline u_int64_t sectors_to_bytes( u_int64_t sectors );
extern int AIX_pvh_data_posn_read(u_int32_t vgda_psn, u_int32_t * pvh_posn, storage_object_t * object, u_int32_t numpvs);
extern int AIX_pvh_data_posn_write(u_int32_t vgda_psn, u_int32_t * pvh_posn, pv_header * * pv_headers, u_int32_t numpvs);
extern int aix_calc_disk_lp_num(lv_entries * lv, int type);

#endif

