/*
 *   Copyright (c) International Business Machines  Corp., 2001
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Module: mdregmgr
 * File: raid1_discover.h
 */

#ifndef _RAID1_MGR_H_
#define _RAID1_MGR_H_ 1


// create options:
#define MD_OPTION_SPARE_DISK_INDEX  	0
#define MD_OPTION_SPARE_DISK_NAME	"sparedisk"
#define MD_NO_SELECTION			"None"


// Plug-in functions
#define MD_RAID1_FUNCTION_FIX			EVMS_Task_Plugin_Function
#define MD_RAID1_FUNCTION_ADD_SPARE		(EVMS_Task_Plugin_Function + 1)
#define MD_RAID1_FUNCTION_ADD_ACTIVE		(EVMS_Task_Plugin_Function + 2)
#define MD_RAID1_FUNCTION_ACTIVATE_SPARE  	(EVMS_Task_Plugin_Function + 3)
#define MD_RAID1_FUNCTION_REMOVE_SPARE  	(EVMS_Task_Plugin_Function + 4)
#define MD_RAID1_FUNCTION_DEACTIVATE_ACTIVE 	(EVMS_Task_Plugin_Function + 5)
#define MD_RAID1_FUNCTION_REMOVE_ACTIVE 	(EVMS_Task_Plugin_Function + 6)
#define MD_RAID1_FUNCTION_REMOVE_FAULTY 	(EVMS_Task_Plugin_Function + 7)
#define MD_RAID1_RESTORE_SUPERBLOCK		(EVMS_Task_Plugin_Function + 8)

#define MD_RAID1_FUNCTION_COUNT			9

#endif

